package es.uv.garcosda.services;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

import org.springframework.stereotype.Service;

import es.uv.garcosda.domain.Mail;
import es.uv.garcosda.domain.Mailbox;
import es.uv.garcosda.domain.User;

@Service
public class UserService {

	private List<User> users;
	private List<Mailbox> mailboxes;
	
	public UserService() {
		users = new ArrayList<User>(
		        Arrays.asList(new User("system@mailer.com","Sys","Admin"),
		        		new User("Quintina.Ardra@yopmail.com","Quintina","Ardra"),
		        		new User("Sybille.Land@yopmail.com","Sybille","Land"),
		        		new User("Kimmy.Elisha@yopmail.com","Kimmy","Elisha"),
		        		new User("Jeanna.McGrody@yopmail.com","Jeanna","McGrody"),
		        		new User("Lelah.Haymes@yopmail.com","Lelah","Haymes"),
		        		new User("Edith.Milson@yopmail.com","Edith","Milson"),
		        		new User("Minne.Eugenia@yopmail.com","Minne","Eugenia"),
		        		new User("Abbie.Brittani@yopmail.com","Abbie","Brittani"),
		        		new User("Brianna.Tacye@yopmail.com","Brianna","Tacye"),
		        		new User("Gabi.Clarissa@yopmail.com","Gabi","Clarissa"),
		        		new User("Aili.Evvie@yopmail.com","Aili","Evvie"),
		        		new User("Jillayne.Plato@yopmail.com","Jillayne","Plato"),
		        		new User("Allis.Daniele@yopmail.com","Allis","Daniele"),
		        		new User("Sam.Guildroy@yopmail.com","Sam","Guildroy"),
		        		new User("Sam.Argus@yopmail.com","Sam","Argus"),
		        		new User("Lorne.Kirbee@yopmail.com","Lorne","Kirbee"),
		        		new User("Brianna.Georgy@yopmail.com","Brianna","Georgy"),
		        		new User("Tarra.Gino@yopmail.com","Tarra","Gino"),
		        		new User("Elvira.Thornburg@yopmail.com","Elvira","Thornburg"),
		        		new User("Paola.Alice@yopmail.com","Paola","Alice")
		       ));
		
		mailboxes = new ArrayList<Mailbox>();
		for(User u : users) {
			mailboxes.add(new Mailbox(u));
		}
		
	}
	
	public List<User> findAll(){
		return this.users;
	}
	
	public User findByEmail(String email) {
		List<User> ps = this.users.stream().filter(x -> x.getEmail().toLowerCase().equals(email.toLowerCase())).collect(Collectors.toList());
		if(ps.size() > 0) {
			return ps.get(0);
		}
		return new User(); 
	}
	
	public boolean addUser(User u) {
		boolean r = this.users.add(u);
		mailboxes.add(new Mailbox(u));
		return r;
	}
	
	public Mailbox findMailboxByEmail(String m) {
		List<Mailbox> boxes = this.mailboxes.stream().filter(x -> x.getUser().getEmail().toLowerCase().equals(m.toLowerCase())).collect(Collectors.toList());
		if(boxes.size() > 0) {
			Mailbox box = boxes.get(0);
			return box;
		}
		return new Mailbox();
	}
	
	public boolean addMail(Mail m) {
		List<Mailbox> boxes = this.mailboxes.stream().filter(x -> x.getUser().getEmail().toLowerCase().equals(m.getTo().getEmail().toLowerCase())).collect(Collectors.toList());
		if(boxes.size() > 0) {
			Mailbox box = boxes.get(0);
			box.addMail(m);
			return true;
		}
		return false;
	}
	
	
}
